/*
In the proc below, replace G_walk_to with any other movement
proc you'd like to see in action.  Check the readme for more
details and implementation information.
*/

obj/movable/New()
	..()
	spawn(rand(1,10)) for()
		var/obj/target/O = locate()

		G_walk_to(O,0,5,10)

		sleep(10)
		while(O) sleep(10)

/*
G_multitile() checks whether the atom is multitile, and if it is,
it creates the components parts.  You may use this selectively to
reduce overhead.  For example, you could stick G_multitile under
mob/large/New() to avoid calling it for all atoms.  But that's up
to you.  BY DEFAULT, THIS PROC IS NOT CALLED ANYWHERE IN THE LIBRARY.
You must call it yourself where appropriate.

The components of multitile atoms may be set as any type of atom.
The argument (in this case /atom/movable) is used to set the components' type.
This may be changed to any type path of your choosing.
*/

atom/movable/New()
	..()
	G_multitile(/atom/movable)

// Defining a mob as multitile is as simple as setting the multitile var.
// Check the readme for more details.

obj/movable
	can_warp = 1	//set this to 1 or 0 as needed for any atom type
	small
		icon = 'small.dmi'
		icon_state = "o"
	large
		icon = 'large.dmi'
		icon_state = "o"
		multitile = FOUR_SQUARE	// <<< notice

turf/warp				//atoms can path-find through warps in some cases
	W1/dest = .W2		//W1 links to W2
	W2/dest = .W1		//W2 links to W1
	W3/dest = .W4		//W3 links to W4
	W4/dest = .W3		//W4 links to W3
	category_A			//an example of how you can organize warps:
		W5/dest = .W6
		W6/dest = .W5
	category_B			//warps can link to each other between categories
						//but you need to expand the destination slightly
		B1/dest = .category_C/C1
		B2/dest = .category_C/C2
	category_C
		C1/dest = .category_B/B1
		C2/dest = .category_B/B2

turf/Click()						//click on the map to place a target
									//used to direct movement in the demo
	var/obj/target/O = locate()		//replaces any existing target
	if(O) del(O)
	O = new /obj/target(src)

// stuff that's not too important yet still necessary for the demo:

world/view = 15			//change this as you see fit

mob
	icon = 'map.dmi'
	icon_state = "PC"
	can_warp = 1
	density = 0
	Login()
		..()
		loc = locate(1,1,1)

obj
	icon = 'map.dmi'
	density = 1
	target
		icon_state = "t"
		density = 0

turf
	icon = 'map.dmi'
	icon_state = "turf"
	wall
		icon_state = "wall"
		density = 1
	warp/icon_state = "warp"